#define LIB_NAME "DecodeOgg"
#define MODULE_NAME "decodeogg"

// include the Defold SDK
#include <dmsdk/sdk.h>
#include <stdlib.h>
#include <vorbis/vorbisenc.h>

static int decodeogg(lua_State* L)
{
    int top = lua_gettop(L);

    //Useless, added to check whether the work of the library.
    vorbis_info      vi; 
    vorbis_info_init(&vi);
    
    // Assert that there is one item on the stack.
    assert(top == lua_gettop(L));

    // Return 1 item
    return 1;
}

// Functions exposed to Lua
static const luaL_reg Module_methods[] =
{
    {"decodeogg", decodeogg},
    {0, 0}
};

static void LuaInit(lua_State* L)
{
    int top = lua_gettop(L);

    // Register lua names
    luaL_register(L, MODULE_NAME, Module_methods);

    lua_pop(L, 1);
    assert(top == lua_gettop(L));
}

dmExtension::Result AppInitializeDecodeOgg(dmExtension::AppParams* params)
{
    return dmExtension::RESULT_OK;
}

dmExtension::Result InitializeDecodeOgg(dmExtension::Params* params)
{
    // Init Lua
    LuaInit(params->m_L);
    printf("Registered %s Extension\n", MODULE_NAME);
    return dmExtension::RESULT_OK;
}

dmExtension::Result AppFinalizeDecodeOgg(dmExtension::AppParams* params)
{
    return dmExtension::RESULT_OK;
}

dmExtension::Result FinalizeDecodeOgg(dmExtension::Params* params)
{
    return dmExtension::RESULT_OK;
}

DM_DECLARE_EXTENSION(DecodeOgg, LIB_NAME, AppInitializeDecodeOgg, AppFinalizeDecodeOgg, InitializeDecodeOgg, 0, 0, FinalizeDecodeOgg)
